var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/*
 * @Description:
 * @Version: 2.0
 * @Autor: zhanghang
 * @Email: suchiva@126.com
 * @Date: 2021-12-07 14:37:20
 * @LastEditors: zhanghang
 * @LastEditTime: 2021-12-08 15:34:06
 */
import Taro from "@tarojs/taro";
import { getPhone } from "../utils/index";
import { initOptions } from "./index";
/**
 * 上报埋点信息
 * @param data  请求参数
 */
var clearFlag;
var autoPull = function (startTime) {
    var dataQueue = Taro.getStorageSync("dataQueue") || [];
    var start = startTime;
    var end;
    clearFlag = setInterval(function () {
        end = new Date().getTime();
        if (end - start >= initOptions.interval) {
            requestData(dataQueue);
        }
    }, 1000);
};
function guid() {
    var d = new Date().getTime();
    var uuid = "xxxxxxxxxxxx4xxxyxxxxxxxxxxxxxxx".replace(/[xy]/g, function (c) {
        var r = (d + Math.random() * 16) % 16 | 0;
        d = Math.floor(d / 16);
        return (c == "x" ? r : (r & 0x3) | 0x8).toString(16);
    });
    return uuid;
}
export var sendData = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var frequency, dataQueue;
    return __generator(this, function (_a) {
        frequency = initOptions.frequency;
        dataQueue = Taro.getStorageSync("dataQueue") || [];
        if (dataQueue && dataQueue.length >= frequency) {
            Taro.setStorageSync("dataQueue", []);
            requestData(dataQueue);
        }
        else if (data.behavior === "init") {
            dataQueue = [];
            dataQueue.push(data);
            Taro.setStorageSync("dataQueue", dataQueue);
            requestData(dataQueue);
        }
        else {
            dataQueue.push(data);
            Taro.setStorageSync("dataQueue", dataQueue);
        }
        return [2 /*return*/];
    });
}); };
var requestData = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var _data, LOGIN_INFO, networkType, dataStr, item;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                clearInterval(clearFlag);
                if (initOptions.appKey == "") {
                    throw new Error("请配置appKey");
                }
                _data = {
                    appKey: initOptions.appKey,
                    envVersion: initOptions.envVersion,
                    currentTime: new Date().valueOf(),
                    phone: getPhone(),
                    deviceId: guid(),
                };
                LOGIN_INFO = Taro.getStorageSync("LOGIN_INFO");
                _data.userId =
                    initOptions.userId ||
                        (LOGIN_INFO ? JSON.parse(LOGIN_INFO).authInfo.userId : "");
                return [4 /*yield*/, Taro.getNetworkType().then(function (res) { return res.networkType; })];
            case 1:
                networkType = _a.sent();
                _data.netType = networkType;
                dataStr = "";
                if (data.length > 0) {
                    data.map(function (v, index) {
                        var item = Object.assign({}, __assign({}, _data), __assign({}, v));
                        var sign = "&";
                        if (index === 0) {
                            sign = "?";
                        }
                        dataStr += sign + "d=" + JSON.stringify(item);
                    });
                }
                else {
                    item = Object.assign({}, __assign({}, _data), __assign({}, data));
                    dataStr += "?d=" + JSON.stringify(item);
                }
                if (initOptions.debug) {
                    // console.log("上报数据------：", dataStr);
                }
                Taro.request({
                    url: initOptions.url + dataStr,
                    method: "GET",
                })
                    .then(function () {
                    if (initOptions.debug) {
                        // console.log("上报成功, 结果为：", res.data);
                        var startTime = new Date().getTime();
                        autoPull(startTime);
                    }
                })
                    .catch(function () {
                    if (initOptions.debug) {
                        // console.log("上报失败，失败原因：", error);
                    }
                });
                return [2 /*return*/];
        }
    });
}); };
